diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc ns-3.36/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc
--- ns-3.35/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc	2022-04-30 18:23:58.146735000 -0700
@@ -21,11 +21,10 @@
  */
 
 #include "ns3/log.h"
+#include "three-gpp-channel-model.h"
 #include "three-gpp-spectrum-propagation-loss-model.h"
 #include "ns3/net-device.h"
-#include "ns3/phased-array-model.h"
 #include "ns3/node.h"
-#include "ns3/channel-condition-model.h"
 #include "ns3/double.h"
 #include "ns3/string.h"
 #include "ns3/simulator.h"
@@ -41,7 +40,6 @@
 ThreeGppSpectrumPropagationLossModel::ThreeGppSpectrumPropagationLossModel ()
 {
   NS_LOG_FUNCTION (this);
-  m_uniformRv = CreateObject<UniformRandomVariable> ();
 }
 
 ThreeGppSpectrumPropagationLossModel::~ThreeGppSpectrumPropagationLossModel ()
@@ -52,7 +50,6 @@
 void
 ThreeGppSpectrumPropagationLossModel::DoDispose ()
 {
-  m_deviceAntennaMap.clear ();
   m_longTermMap.clear ();
   m_channelModel->Dispose ();
   m_channelModel = nullptr;
@@ -62,7 +59,7 @@
 ThreeGppSpectrumPropagationLossModel::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::ThreeGppSpectrumPropagationLossModel")
-    .SetParent<SpectrumPropagationLossModel> ()
+    .SetParent<PhasedArraySpectrumPropagationLossModel> ()
     .SetGroupName ("Spectrum")
     .AddConstructor<ThreeGppSpectrumPropagationLossModel> ()
     .AddAttribute("ChannelModel", 
@@ -71,13 +68,6 @@
                   MakePointerAccessor (&ThreeGppSpectrumPropagationLossModel::SetChannelModel,
                                        &ThreeGppSpectrumPropagationLossModel::GetChannelModel),
                                        MakePointerChecker<MatrixBasedChannelModel> ())
-    .AddAttribute ("vScatt",
-                   "Maximum speed of the vehicle in the layout (see 3GPP TR 37.885 v15.3.0, Sec. 6.2.3)."
-                   "Used to compute the additional contribution for the Doppler of" 
-                   "delayed (reflected) paths",
-                   DoubleValue (0.0),
-                   MakeDoubleAccessor (&ThreeGppSpectrumPropagationLossModel::m_vScatt),
-                   MakeDoubleChecker<double> (0.0))
     ;
   return tid;
 }
@@ -94,13 +84,6 @@
   return m_channelModel;
 }
 
-void
-ThreeGppSpectrumPropagationLossModel::AddDevice (Ptr<NetDevice> n, Ptr<const PhasedArrayModel> a)
-{
-  NS_ASSERT_MSG (m_deviceAntennaMap.find (n->GetNode ()->GetId ()) == m_deviceAntennaMap.end (), "Device is already present in the map");
-  m_deviceAntennaMap.insert (std::make_pair (n->GetNode ()->GetId (), a));
-}
-
 double
 ThreeGppSpectrumPropagationLossModel::GetFrequency () const
 {
@@ -131,18 +114,24 @@
   uint16_t sAntenna = static_cast<uint16_t> (sW.size ());
   uint16_t uAntenna = static_cast<uint16_t> (uW.size ());
 
+  NS_ASSERT (uAntenna == params->m_channel.size ());
+  NS_ASSERT (sAntenna == params->m_channel.at (0).size());
+
   NS_LOG_DEBUG ("CalcLongTerm with sAntenna " << sAntenna << " uAntenna " << uAntenna);
   //store the long term part to reduce computation load
   //only the small scale fading needs to be updated if the large scale parameters and antenna weights remain unchanged.
   PhasedArrayModel::ComplexVector longTerm;
   uint8_t numCluster = static_cast<uint8_t> (params->m_channel[0][0].size ());
 
+  NS_ASSERT (uAntenna == params->m_channel.size ());
+  NS_ASSERT (sAntenna == params->m_channel.at (0).size());
+
   for (uint8_t cIndex = 0; cIndex < numCluster; cIndex++)
     {
-      std::complex<double> txSum (0,0);
+      std::complex<double> txSum (0, 0);
       for (uint16_t sIndex = 0; sIndex < sAntenna; sIndex++)
         {
-          std::complex<double> rxSum (0,0);
+          std::complex<double> rxSum (0, 0);
           for (uint16_t uIndex = 0; uIndex < uAntenna; uIndex++)
             {
               rxSum = rxSum + uW[uIndex] * params->m_channel[uIndex][sIndex][cIndex];
@@ -157,7 +146,8 @@
 Ptr<SpectrumValue>
 ThreeGppSpectrumPropagationLossModel::CalcBeamformingGain (Ptr<SpectrumValue> txPsd,
                                                            PhasedArrayModel::ComplexVector longTerm,
-                                                           Ptr<const MatrixBasedChannelModel::ChannelMatrix> params,
+                                                           Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
+                                                           Ptr<const MatrixBasedChannelModel::ChannelParams> channelParams,
                                                            const ns3::Vector &sSpeed, const ns3::Vector &uSpeed) const
 {
   NS_LOG_FUNCTION (this);
@@ -165,58 +155,97 @@
   Ptr<SpectrumValue> tempPsd = Copy<SpectrumValue> (txPsd);
 
   //channel[rx][tx][cluster]
-  uint8_t numCluster = static_cast<uint8_t> (params->m_channel[0][0].size ());
+  uint8_t numCluster = static_cast<uint8_t> (channelMatrix->m_channel[0][0].size ());
 
   // compute the doppler term
   // NOTE the update of Doppler is simplified by only taking the center angle of
   // each cluster in to consideration.
   double slotTime = Simulator::Now ().GetSeconds ();
+  double factor = 2 * M_PI * slotTime * GetFrequency () / 3e8;
   PhasedArrayModel::ComplexVector doppler;
+
+  // The following asserts might seem paranoic, but it is important to
+  // make sure that all the structures that are passed to this function
+  // are of the correct dimensions before using the operator [].
+  // If you dont understand the comment read about the difference of .at()
+  // and [] operators, ...
+  NS_ASSERT (numCluster <= channelParams->m_alpha.size ());
+  NS_ASSERT (numCluster <= channelParams->m_D.size());
+  NS_ASSERT (numCluster <= channelParams->m_angle[MatrixBasedChannelModel::ZOA_INDEX].size());
+  NS_ASSERT (numCluster <= channelParams->m_angle[MatrixBasedChannelModel::ZOD_INDEX].size());
+  NS_ASSERT (numCluster <= channelParams->m_angle[MatrixBasedChannelModel::AOA_INDEX].size());
+  NS_ASSERT (numCluster <= channelParams->m_angle[MatrixBasedChannelModel::AOD_INDEX].size());
+  NS_ASSERT (numCluster <= longTerm.size());
+
+  // check if channelParams structure is generated in direction s-to-u or u-to-s
+  bool isSameDirection = (channelParams->m_nodeIds == channelMatrix->m_nodeIds);
+
+  MatrixBasedChannelModel::DoubleVector zoa;
+  MatrixBasedChannelModel::DoubleVector zod;
+  MatrixBasedChannelModel::DoubleVector aoa;
+  MatrixBasedChannelModel::DoubleVector aod;
+
+  // if channel params is generated in the same direction in which we
+  // generate the channel matrix, angles and zenit od departure and arrival are ok,
+  // just set them to corresponding variable that will be used for the generation
+  // of channel matrix, otherwise we need to flip angles and zenits of departure and arrival
+  if (isSameDirection)
+    {
+      zoa = channelParams->m_angle[MatrixBasedChannelModel::ZOA_INDEX];
+      zod = channelParams->m_angle[MatrixBasedChannelModel::ZOD_INDEX];
+      aoa = channelParams->m_angle[MatrixBasedChannelModel::AOA_INDEX];
+      aod = channelParams->m_angle[MatrixBasedChannelModel::AOD_INDEX];
+    }
+  else
+    {
+      zod = channelParams->m_angle[MatrixBasedChannelModel::ZOA_INDEX];
+      zoa = channelParams->m_angle[MatrixBasedChannelModel::ZOD_INDEX];
+      aod = channelParams->m_angle[MatrixBasedChannelModel::AOA_INDEX];
+      aoa = channelParams->m_angle[MatrixBasedChannelModel::AOD_INDEX];
+    }
+
   for (uint8_t cIndex = 0; cIndex < numCluster; cIndex++)
     {
       // Compute alpha and D as described in 3GPP TR 37.885 v15.3.0, Sec. 6.2.3
-      // These terms account for an additional Doppler contribution due to the 
-      // presence of moving objects in the sorrounding environment, such as in 
+      // These terms account for an additional Doppler contribution due to the
+      // presence of moving objects in the sorrounding environment, such as in
       // vehicular scenarios.
-      // This contribution is applied only to the delayed (reflected) paths and 
-      // must be properly configured by setting the value of 
-      // m_vScatt, which is defined as "maximum speed of the vehicle in the 
-      // layout". 
-      // By default, m_vScatt is set to 0, so there is no additional Doppler 
+      // This contribution is applied only to the delayed (reflected) paths and
+      // must be properly configured by setting the value of
+      // m_vScatt, which is defined as "maximum speed of the vehicle in the
+      // layout".
+      // By default, m_vScatt is set to 0, so there is no additional Doppler
       // contribution.
-      double alpha = 0; 
-      double D = 0; 
-      if (cIndex != 0)
-      {
-        alpha = m_uniformRv->GetValue (-1, 1);
-        D = m_uniformRv->GetValue (-m_vScatt, m_vScatt);
-      }
-      
-      //cluster angle angle[direction][n],where, direction = 0(aoa), 1(zoa).
-      double temp_doppler = 2 * M_PI * ((sin (params->m_angle[MatrixBasedChannelModel::ZOA_INDEX][cIndex] * M_PI / 180) * cos (params->m_angle[MatrixBasedChannelModel::AOA_INDEX][cIndex] * M_PI / 180) * uSpeed.x
-                                         + sin (params->m_angle[MatrixBasedChannelModel::ZOA_INDEX][cIndex] * M_PI / 180) * sin (params->m_angle[MatrixBasedChannelModel::AOA_INDEX][cIndex] * M_PI / 180) * uSpeed.y
-                                         + cos (params->m_angle[MatrixBasedChannelModel::ZOA_INDEX][cIndex] * M_PI / 180) * uSpeed.z)
-                                         + (sin (params->m_angle[MatrixBasedChannelModel::ZOD_INDEX][cIndex] * M_PI / 180) * cos (params->m_angle[MatrixBasedChannelModel::AOD_INDEX][cIndex] * M_PI / 180) * sSpeed.x
-                                         + sin (params->m_angle[MatrixBasedChannelModel::ZOD_INDEX][cIndex] * M_PI / 180) * sin (params->m_angle[MatrixBasedChannelModel::AOD_INDEX][cIndex] * M_PI / 180) * sSpeed.y
-                                         + cos (params->m_angle[MatrixBasedChannelModel::ZOD_INDEX][cIndex] * M_PI / 180) * sSpeed.z) + 2 * alpha * D)
-                           * slotTime * GetFrequency () / 3e8;
-      doppler.push_back (exp (std::complex<double> (0, temp_doppler)));
+
+      double alpha = channelParams->m_alpha [cIndex];
+      double D = channelParams->m_D [cIndex];
+
+      //cluster angle angle[direction][n], where direction = 0(aoa), 1(zoa).
+      double tempDoppler = factor * ((sin (zoa [cIndex] * M_PI / 180) * cos (aoa [cIndex] * M_PI / 180) * uSpeed.x
+                                       + sin (zoa [cIndex] * M_PI / 180) * sin (aoa [cIndex] * M_PI / 180) * uSpeed.y
+                                       + cos (zoa [cIndex] * M_PI / 180) * uSpeed.z)
+                                       + (sin (zod [cIndex] * M_PI / 180) * cos (aod [cIndex] * M_PI / 180) * sSpeed.x
+                                       + sin (zod [cIndex] * M_PI / 180) * sin (aod [cIndex] * M_PI / 180) * sSpeed.y
+                                       + cos (zod [cIndex] * M_PI / 180) * sSpeed.z) + 2 * alpha * D);
+      doppler.push_back (std::complex<double> (cos (tempDoppler), sin (tempDoppler)));
     }
 
+  NS_ASSERT (numCluster <= doppler.size());
+
   // apply the doppler term and the propagation delay to the long term component
   // to obtain the beamforming gain
   auto vit = tempPsd->ValuesBegin (); // psd iterator
-  auto sbit = tempPsd->ConstBandsBegin(); // band iterator
+  auto sbit = tempPsd->ConstBandsBegin (); // band iterator
   while (vit != tempPsd->ValuesEnd ())
     {
-      std::complex<double> subsbandGain (0.0,0.0);
       if ((*vit) != 0.00)
         {
+          std::complex<double> subsbandGain (0.0, 0.0);
           double fsb = (*sbit).fc; // center frequency of the sub-band
           for (uint8_t cIndex = 0; cIndex < numCluster; cIndex++)
             {
-              double delay = -2 * M_PI * fsb * (params->m_delay[cIndex]);
-              subsbandGain = subsbandGain + longTerm[cIndex] * doppler[cIndex] * exp (std::complex<double> (0, delay));
+              double delay = -2 * M_PI * fsb * (channelParams->m_delay[cIndex]);
+              subsbandGain = subsbandGain + longTerm[cIndex] * doppler[cIndex] * std::complex<double> (cos (delay), sin (delay));
             }
           *vit = (*vit) * (norm (subsbandGain));
         }
@@ -227,54 +256,51 @@
 }
 
 PhasedArrayModel::ComplexVector
-ThreeGppSpectrumPropagationLossModel::GetLongTerm (uint32_t aId, uint32_t bId,
-                                                   Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
-                                                   const PhasedArrayModel::ComplexVector &aW,
-                                                   const PhasedArrayModel::ComplexVector &bW) const
+ThreeGppSpectrumPropagationLossModel::GetLongTerm (Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
+                                                   Ptr<const PhasedArrayModel> aPhasedArrayModel,
+                                                   Ptr<const PhasedArrayModel> bPhasedArrayModel) const
 {
   PhasedArrayModel::ComplexVector longTerm; // vector containing the long term component for each cluster
 
   // check if the channel matrix was generated considering a as the s-node and
   // b as the u-node or viceversa
   PhasedArrayModel::ComplexVector sW, uW;
-  if (!channelMatrix->IsReverse (aId, bId))
+  if (!channelMatrix->IsReverse (aPhasedArrayModel->GetId (), bPhasedArrayModel->GetId ()))
   {
-    sW = aW;
-    uW = bW;
+    sW = aPhasedArrayModel->GetBeamformingVector ();
+    uW = bPhasedArrayModel->GetBeamformingVector ();
   }
   else
   {
-    sW = bW;
-    uW = aW;
+    sW = bPhasedArrayModel->GetBeamformingVector ();
+    uW = aPhasedArrayModel->GetBeamformingVector ();
   }
 
-  // compute the long term key, the key is unique for each tx-rx pair
-  uint32_t x1 = std::min (aId, bId);
-  uint32_t x2 = std::max (aId, bId);
-  uint32_t longTermId = MatrixBasedChannelModel::GetKey (x1, x2);
-
   bool update = false; // indicates whether the long term has to be updated
   bool notFound = false; // indicates if the long term has not been computed yet
 
+  // compute the long term key, the key is unique for each tx-rx pair
+  uint64_t longTermId = MatrixBasedChannelModel::GetKey (aPhasedArrayModel->GetId (), bPhasedArrayModel->GetId ());
+
   // look for the long term in the map and check if it is valid
   if (m_longTermMap.find (longTermId) != m_longTermMap.end ())
-  {
-    NS_LOG_DEBUG ("found the long term component in the map");
-    longTerm = m_longTermMap[longTermId]->m_longTerm;
+    {
+      NS_LOG_DEBUG ("found the long term component in the map");
+      longTerm = m_longTermMap[longTermId]->m_longTerm;
 
-    // check if the channel matrix has been updated
-    // or the s beam has been changed
-    // or the u beam has been changed
-    update = (m_longTermMap[longTermId]->m_channel->m_generatedTime != channelMatrix->m_generatedTime
-              || m_longTermMap[longTermId]->m_sW != sW
-              || m_longTermMap[longTermId]->m_uW != uW);
+      // check if the channel matrix has been updated
+      // or the s beam has been changed
+      // or the u beam has been changed
+      update = (m_longTermMap[longTermId]->m_channel->m_generatedTime != channelMatrix->m_generatedTime
+                || m_longTermMap[longTermId]->m_sW != sW
+                || m_longTermMap[longTermId]->m_uW != uW);
 
-  }
+    }
   else
-  {
-    NS_LOG_DEBUG ("long term component NOT found");
-    notFound = true;
-  }
+    {
+      NS_LOG_DEBUG ("long term component NOT found");
+      notFound = true;
+    }
 
   if (update || notFound)
     {
@@ -298,7 +324,9 @@
 Ptr<SpectrumValue>
 ThreeGppSpectrumPropagationLossModel::DoCalcRxPowerSpectralDensity (Ptr<const SpectrumValue> txPsd,
                                                                     Ptr<const MobilityModel> a,
-                                                                    Ptr<const MobilityModel> b) const
+                                                                    Ptr<const MobilityModel> b,
+                                                                    Ptr<const PhasedArrayModel> aPhasedArrayModel,
+                                                                    Ptr<const PhasedArrayModel> bPhasedArrayModel) const
 {
   NS_LOG_FUNCTION (this);
   uint32_t aId = a->GetObject<Node> ()->GetId (); // id of the node a
@@ -310,26 +338,21 @@
   Ptr<SpectrumValue> rxPsd = Copy<SpectrumValue> (txPsd);
 
   // retrieve the antenna of device a
-  NS_ASSERT_MSG (m_deviceAntennaMap.find (aId) != m_deviceAntennaMap.end (), "Antenna not found for node " << aId);
-  Ptr<const PhasedArrayModel> aAntenna = m_deviceAntennaMap.at (aId);
-  NS_LOG_DEBUG ("a node " << a->GetObject<Node> () << " antenna " << aAntenna);
+  NS_ASSERT_MSG (aPhasedArrayModel, "Antenna not found for node " << aId);
+  NS_LOG_DEBUG ("a node " << a->GetObject<Node> () << " antenna " << aPhasedArrayModel);
 
   // retrieve the antenna of the device b
-  NS_ASSERT_MSG (m_deviceAntennaMap.find (bId) != m_deviceAntennaMap.end (), "Antenna not found for device " << bId);
-  Ptr<const PhasedArrayModel> bAntenna = m_deviceAntennaMap.at (bId);
-  NS_LOG_DEBUG ("b node " << bId << " antenna " << bAntenna);
-
-  Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix = m_channelModel->GetChannel (a, b, aAntenna, bAntenna);
-
-  // get the precoding and combining vectors
-  PhasedArrayModel::ComplexVector aW = aAntenna->GetBeamformingVector ();
-  PhasedArrayModel::ComplexVector bW = bAntenna->GetBeamformingVector ();
+  NS_ASSERT_MSG (bPhasedArrayModel, "Antenna not found for device " << bId);
+  NS_LOG_DEBUG ("b node " << bId << " antenna " << bPhasedArrayModel);
+
+  Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix = m_channelModel->GetChannel (a, b, aPhasedArrayModel, bPhasedArrayModel);
+  Ptr<const MatrixBasedChannelModel::ChannelParams> channelParams = m_channelModel->GetParams (a, b);
 
   // retrieve the long term component
-  PhasedArrayModel::ComplexVector longTerm = GetLongTerm (aId, bId, channelMatrix, aW, bW);
+  PhasedArrayModel::ComplexVector longTerm = GetLongTerm (channelMatrix, aPhasedArrayModel, bPhasedArrayModel);
 
   // apply the beamforming gain
-  rxPsd = CalcBeamformingGain (rxPsd, longTerm, channelMatrix, a->GetVelocity (), b->GetVelocity ());
+  rxPsd = CalcBeamformingGain (rxPsd, longTerm, channelMatrix, channelParams, a->GetVelocity (), b->GetVelocity ());
 
   return rxPsd;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h ns-3.36/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h
--- ns-3.35/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h	2022-04-30 18:23:58.146735000 -0700
@@ -22,18 +22,16 @@
 #ifndef THREE_GPP_SPECTRUM_PROPAGATION_LOSS_H
 #define THREE_GPP_SPECTRUM_PROPAGATION_LOSS_H
 
-#include "ns3/spectrum-propagation-loss-model.h"
 #include <complex.h>
 #include <map>
 #include <unordered_map>
 #include "ns3/matrix-based-channel-model.h"
 #include "ns3/random-variable-stream.h"
+#include "ns3/phased-array-spectrum-propagation-loss-model.h"
 
 namespace ns3 {
 
 class NetDevice;
-class ChannelConditionModel;
-class ChannelCondition;
 
 /**
  * \ingroup spectrum
@@ -49,7 +47,7 @@
  * \see PhasedArrayModel
  * \see ChannelCondition
  */
-class ThreeGppSpectrumPropagationLossModel : public SpectrumPropagationLossModel
+class ThreeGppSpectrumPropagationLossModel : public PhasedArraySpectrumPropagationLossModel
 {
 public:
   /**
@@ -61,7 +59,7 @@
    * Destructor
    */
   ~ThreeGppSpectrumPropagationLossModel ();
-  
+
   void DoDispose () override;
 
   /**
@@ -80,15 +78,7 @@
    * Get the channel model object
    * \return a pointer to the object implementing the MatrixBasedChannelModel interface
    */
-  Ptr<MatrixBasedChannelModel> GetChannelModel() const;
-
-  /**
-   * Add a device-antenna pair
-   * \param n a pointer to the NetDevice
-   * \param a a pointer to the associated PhasedArrayModel
-   */
-  void AddDevice (Ptr<NetDevice> n, Ptr<const PhasedArrayModel> a);
-
+  Ptr<MatrixBasedChannelModel> GetChannelModel () const;
 
   /**
    * Sets the value of an attribute belonging to the associated
@@ -102,7 +92,7 @@
    * Returns the value of an attribute belonging to the associated
    * MatrixBasedChannelModel instance
    * \param name name of the attribute
-   * \param where the result should be stored
+   * \param value where the result should be stored
    */
   void GetChannelModelAttribute (const std::string &name, AttributeValue &value) const;
 
@@ -123,12 +113,15 @@
    * \param txPsd tx PSD
    * \param a first node mobility model
    * \param b second node mobility model
-   *
+   * \param aPhasedArrayModel the antenna array of the first node
+   * \param bPhasedArrayModel the antenna array of the second node
    * \return the received PSD
    */
   Ptr<SpectrumValue> DoCalcRxPowerSpectralDensity (Ptr<const SpectrumValue> txPsd,
-                                                           Ptr<const MobilityModel> a,
-                                                           Ptr<const MobilityModel> b) const override;
+                                                   Ptr<const MobilityModel> a,
+                                                   Ptr<const MobilityModel> b,
+                                                   Ptr<const PhasedArrayModel> aPhasedArrayModel,
+                                                   Ptr<const PhasedArrayModel> bPhasedArrayModel) const override;
 
 private:
   /**
@@ -152,17 +145,14 @@
    * Looks for the long term component in m_longTermMap. If found, checks
    * whether it has to be updated. If not found or if it has to be updated,
    * calls the method CalcLongTerm to compute it.
-   * \param aId id of the first node
-   * \param bId id of the second node
    * \param channelMatrix the channel matrix
-   * \param aW the beamforming vector of the first device
-   * \param bW the beamforming vector of the second device
-   * \return vector containing the long term compoenent for each cluster
-   */
-  PhasedArrayModel::ComplexVector GetLongTerm (uint32_t aId, uint32_t bId,
-                                                        Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
-                                                        const PhasedArrayModel::ComplexVector &aW,
-                                                        const PhasedArrayModel::ComplexVector &bW) const;
+   * \param aPhasedArrayModel the antenna array of the tx device
+   * \param bPhasedArrayModel the antenna array of the rx device
+   * \return vector containing the long term component for each cluster
+   */
+  PhasedArrayModel::ComplexVector GetLongTerm (Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
+                                               Ptr<const PhasedArrayModel> aPhasedArrayModel,
+                                               Ptr<const PhasedArrayModel> bPhasedArrayModel) const;
   /**
    * Computes the long term component
    * \param channelMatrix the channel matrix H
@@ -171,31 +161,27 @@
    * \return the long term component
    */
   PhasedArrayModel::ComplexVector CalcLongTerm (Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
-                                                         const PhasedArrayModel::ComplexVector &sW,
-                                                         const PhasedArrayModel::ComplexVector &uW) const;
+                                                const PhasedArrayModel::ComplexVector &sW,
+                                                const PhasedArrayModel::ComplexVector &uW) const;
 
   /**
    * Computes the beamforming gain and applies it to the tx PSD
    * \param txPsd the tx PSD
    * \param longTerm the long term component
-   * \param params The channel matrix
+   * \param channelMatrix The channel matrix structure
+   * \param channelParams The channel params structure
    * \param sSpeed speed of the first node
    * \param uSpeed speed of the second node
    * \return the rx PSD
    */
   Ptr<SpectrumValue> CalcBeamformingGain (Ptr<SpectrumValue> txPsd,
                                           PhasedArrayModel::ComplexVector longTerm,
-                                          Ptr<const MatrixBasedChannelModel::ChannelMatrix> params,
+                                          Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
+                                          Ptr<const MatrixBasedChannelModel::ChannelParams> channelParams,
                                           const Vector &sSpeed, const Vector &uSpeed) const;
 
-  std::unordered_map <uint32_t, Ptr<const PhasedArrayModel> > m_deviceAntennaMap; //!< map containig the <node, antenna> associations
-  mutable std::unordered_map < uint32_t, Ptr<const LongTerm> > m_longTermMap; //!< map containing the long term components
+  mutable std::unordered_map < uint64_t, Ptr<const LongTerm> > m_longTermMap; //!< map containing the long term components
   Ptr<MatrixBasedChannelModel> m_channelModel; //!< the model to generate the channel matrix
-  
-  // Variable used to compute the additional Doppler contribution for the delayed 
-  // (reflected) paths, as described in 3GPP TR 37.885 v15.3.0, Sec. 6.2.3.
-  double m_vScatt; //!< value used to compute the additional Doppler contribution for the delayed paths 
-  Ptr<UniformRandomVariable> m_uniformRv; //!< uniform random variable, used to compute the additional Doppler contribution
 };
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/tv-spectrum-transmitter.cc ns-3.36/src/spectrum/model/tv-spectrum-transmitter.cc
--- ns-3.35/src/spectrum/model/tv-spectrum-transmitter.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/tv-spectrum-transmitter.cc	2022-04-30 18:23:58.150735000 -0700
@@ -164,8 +164,8 @@
   return 0;
 }
 
-Ptr<AntennaModel>
-TvSpectrumTransmitter::GetRxAntenna () const
+Ptr<Object>
+TvSpectrumTransmitter::GetAntenna () const
 {
   NS_LOG_FUNCTION (this);
   return m_antenna;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/tv-spectrum-transmitter.h ns-3.36/src/spectrum/model/tv-spectrum-transmitter.h
--- ns-3.35/src/spectrum/model/tv-spectrum-transmitter.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/tv-spectrum-transmitter.h	2022-04-30 18:23:58.150735000 -0700
@@ -74,7 +74,7 @@
   Ptr<NetDevice> GetDevice () const;
   // device does not use Rx but these pure virtual methods must be implemented
   Ptr<const SpectrumModel> GetRxSpectrumModel () const;
-  Ptr<AntennaModel> GetRxAntenna () const;
+  Ptr<Object> GetAntenna () const;
   void StartRx (Ptr<SpectrumSignalParameters> params);
 
   /** 
@@ -103,9 +103,6 @@
    * Analog PSD approximated from Figure 4 of the following paper:
    * Stephen Shellhammer, Ahmed Sadek, and Wenyi Zhang. "Technical Challenges 
    * for Cognitive Radio in the TV White Space Spectrum." Qualcomm Incorporated.
-   *
-   *
-   * @return a pointer to the power spectral density of the TV transmitter
    */
   virtual void CreateTvPsd ();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/waveform-generator.cc ns-3.36/src/spectrum/model/waveform-generator.cc
--- ns-3.35/src/spectrum/model/waveform-generator.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/waveform-generator.cc	2022-04-30 18:23:58.150735000 -0700
@@ -154,8 +154,8 @@
   m_txPowerSpectralDensity = txPsd;
 }
 
-Ptr<AntennaModel>
-WaveformGenerator::GetRxAntenna () const
+Ptr<Object>
+WaveformGenerator::GetAntenna () const
 {
   return m_antenna;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/waveform-generator.h ns-3.36/src/spectrum/model/waveform-generator.h
--- ns-3.35/src/spectrum/model/waveform-generator.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/waveform-generator.h	2022-04-30 18:23:58.150735000 -0700
@@ -70,7 +70,7 @@
   Ptr<MobilityModel> GetMobility () const;
   Ptr<NetDevice> GetDevice () const;
   Ptr<const SpectrumModel> GetRxSpectrumModel () const;
-  Ptr<AntennaModel> GetRxAntenna () const;
+  Ptr<Object> GetAntenna () const;
   void StartRx (Ptr<SpectrumSignalParameters> params);
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/test/spectrum-ideal-phy-test.cc ns-3.36/src/spectrum/test/spectrum-ideal-phy-test.cc
--- ns-3.35/src/spectrum/test/spectrum-ideal-phy-test.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/test/spectrum-ideal-phy-test.cc	2022-04-30 18:23:58.150735000 -0700
@@ -64,9 +64,21 @@
 }
 
 
+/**
+ * \ingroup spectrum-tests
+ *
+ * \brief Ideal Spectrum PHY Test
+ */
 class SpectrumIdealPhyTestCase : public TestCase
 {
 public:
+  /**
+   * Constructor
+   * \param snrLinear SNR (linear)
+   * \param phyRate PHY rate (bps)
+   * \param rateIsAchievable Check if the rate is achievable
+   * \param channelType Channel type
+   */
   SpectrumIdealPhyTestCase (double snrLinear,
 			    uint64_t phyRate,
 			    bool rateIsAchievable,
@@ -75,12 +87,19 @@
 
 private:
   virtual void DoRun (void);
+  /**
+   * Get the test name
+   * \param channelType Channel type
+   * \param snrLinear SNR (linear)
+   * \param phyRate PHY rate (bps)
+   * \return the test name
+   */
   static std::string Name (std::string channelType, double snrLinear, uint64_t phyRate);
   
-  double      m_snrLinear;
-  uint64_t    m_phyRate;
-  bool        m_rateIsAchievable;
-  std::string m_channelType;
+  double      m_snrLinear;        //!< SNR (linear)
+  uint64_t    m_phyRate;          //!< PHY rate (bps)
+  bool        m_rateIsAchievable; //!< Check if the rate is achievable
+  std::string m_channelType;      //!< Channel type
 };
 
 std::string 
@@ -210,7 +229,11 @@
 
 
 
-
+/**
+ * \ingroup spectrum-tests
+ *
+ * \brief Ideal Spectrum PHY TestSuite
+ */
 class SpectrumIdealPhyTestSuite : public TestSuite
 {
 public:
@@ -245,4 +268,5 @@
     }
 }
 
+/// Static variable for test initialization
 static SpectrumIdealPhyTestSuite g_spectrumIdealPhyTestSuite;
